/********************************** (C) COPYRIGHT *******************************
* File Name          : MAIN.C
* Author             : MJX
* Version            : V1.00
* Date               : 2021/01/22
* Description        : CH569HSPIʵ˫ͨ
* ˵
*                      (1)2CH569ֱΪHOSTSLAVERеͨв;
*                           1K,ͻΪ48;
*                           ʵٶ: Լ400Mֽ/S; 48M/0.12046 = 398M;
*
*                      (2)2CH569ֱΪHOSTSLAVER˫ͨв;
*                           HOSTSLAVER1,SLAVERHOSTظ1С;
*                           1K,ͻΪ48;
*                           ʵٶ: Լ389Mֽ/S; 48M/0.12343 = 389M;
*                           ϰӼж,ʵٶ: Լ340Mֽ/S;
*
*                      (3)ͨ޸DEF_HSPI_MODEлHOSTSLAVERģʽ;
*                           ͨ޸DEF_HSPI_DOUBLE_DIR_ENΪ01лԻ˫;
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "MAIN.h"                                                               /* ͷļ */

/******************************************************************************/
/*  */
UINT8V  USB_WorkMode = DEF_MODE_BULK;                                           /* USBģʽ: 0: ģʽ; 1: UVCͬģʽ; */

UINT32V Dbg_Idle_TimeCount = 0x00;
UINT64V Dbg_HSPI_Tx_TLen = 0x00;
UINT64V Dbg_HSPI_Rx_TLen = 0x00;

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void )
{
    UINT32 i,j;

    /*****************************ϵͳسʼ*******************************/
    SystemInit( FREQ_SYS );
	Delay_Init( FREQ_SYS );

    /*****************************ģųʼ**************************/
	UART1_Init( DEF_UART1_BAUDRATE );
	HSPI_GPIO_Init( );                                                          /* HSPIӿGPIOʼ */
    GPIO_Init( );                                                               /* ӲGPIOʼ */
	DUG_PRINTF("CH56x HSPI Test@120MHZ_V1.%d\n",(UINT16)DEF_PROG_VERSION - 0x01 );
    DUG_PRINTF("Edit Date and Time is: "__DATE__"  " __TIME__"\n");
    DUG_PRINTF("USB_WorkMode: %x\n",(UINT16)USB_WorkMode);

    /*****************************ʱسʼ **************************/
    Timer1_Init( 240000 );                                                      /* ʱ1ʼ(ʱ2mS) */

    /*******************************************************************/
    DUG_PRINTF("Main\n");

    /*****************************HSPI*************************************/
    /* PB24Ϊ,Ϊ16mA */
    R32_PB_DIR |= ( ( 1 << 24 ) );
    R32_PB_DRV |= ( ( 1 << 24 ) );
    R32_PB_PU &= ~( ( 1 << 24 ) );
    R32_PB_PD &= ~( ( 1 << 24 ) );

    PFIC_SetPriority( TMR0_IRQn, 0x80 );
    PFIC_SetPriority( HSPI_IRQn, 0x00 );

    Dbg_Idle_TimeCount = 0x00;
    Dbg_HSPI_Tx_TLen = 0x00;
    Dbg_HSPI_Rx_TLen = 0x00;
    Delay_mS( 100 );

    /* ݲͬģʽвͬ */
    USB_WorkMode = DEF_MODE_UVC;
    if( USB_WorkMode == DEF_MODE_BULK )
    {
        BULKMode_HSPI_Test( );
    }
    else
    {
        UVCMode_HSPI_Test( );
    }
	while( 1 );
}
